import 'dart:math';

import 'package:germanet_dart/src/compoundinfo.dart';
import 'package:germanet_dart/src/synset.dart';

/// the dart adaption for python reduce (list)
dynamic reduce(Function function, Iterable sequence){
  dynamic value = sequence.first;
  for(var element in sequence){
    value = function.call(value, element);
  }
}

/// the dart adaption to operlapping fastEnum properties in python
WordCategory simplifyEnumClass(CompoundCategory cat){
  if(cat == CompoundCategory.Adjektiv){
    return WordCategory.adj;
  }
  if(cat == CompoundCategory.Nomen){
    return WordCategory.nomen;
  }
  if(cat == CompoundCategory.Verb){
    return WordCategory.verben;
  }
  print("::simplifyEnumClass->no overlapping cat found, returning null");
  return WordCategory.none;
}

/// the dart adaption to python: zip(a, b)
List zip(List a, List b){

  List o = [];
  for (var i = 0; i < min(a.length, b.length); i++) {
    o.add([a[i], b[i]]);
  }
  return o;
}

/// the dart adaption to python: dict(zip(a, b))
Map directZipMap(List a, List b){

  Map m = {};
  for (var i = 0; i < min(a.length, b.length); i++) {
    m[a[i]] = b[i];
  }
  return m;

}

///round double val int places
double dp(double val, int places){ 
   num mod = pow(10.0, places); 
   return ((val * mod).round().toDouble() / mod); 
  }