import 'package:germanet_dart/src/compoundinfo.dart';
import 'package:germanet_dart/src/synset.dart';

enum LexRel {
    has_synonym('has_synonym'),    has_antonym('has_antonym'),    has_pertainym('has_pertainym'),    has_participle('has_participle'),    has_active_usage('has_active_usage'),    has_occasion('has_occasion'),    has_attribute('has_attribute'),    has_appearance('has_appearance'),    has_construction_method('has_construction_method'),    has_container('has_container'),    is_container_for('is_container_for'),    has_consistency_of('has_consistency_of'),    has_component('has_component'),    has_owner('has_owner'),    is_owner_of('is_owner_of'),    has_function('has_function'),    has_manner_of_functioning('has_manner_of_functioning'),    has_origin('has_origin'),    has_production_method('has_production_method'),    has_content('has_content'),    has_no_property('has_no_property'),    has_habitat('has_habitat'),    has_location('has_location'),    is_location_of('is_location_of'),    has_measure('has_measure'),    is_measure_of('is_measure_of'),    has_material('has_material'),    has_member('has_member'),    is_member_of('is_member_of'),    has_diet('has_diet'),    is_diet_of('is_diet_of'),    has_eponym('has_eponym'),    has_user('has_user'),    has_product('has_product'),    is_product_of('is_product_of'),    has_prototypical_holder('has_prototypical_holder'),    is_prototypical_holder_for('is_prototypical_holder_for'),    has_prototypical_place_of_usage('has_prototypical_place_of_usage'),    has_relation('has_relation'),    has_raw_product('has_raw_product'),    has_other_property('has_other_property'),    is_storage_for('is_storage_for'),    has_specialization('has_specialization'),    has_part('has_part'),    is_part_of('is_part_of'),    has_topic('has_topic'),    is_caused_by('is_caused_by'),    is_cause_for('is_cause_for'),    is_comparable_to('is_comparable_to'),    has_usage('has_usage'),    has_result_of_usage('has_result_of_usage'),    has_purpose_of_usage('has_purpose_of_usage'),    has_goods('has_goods'),    has_time('has_time'),    is_access_to('is_access_to',),    has_ingredient('has_ingredient',),    is_ingredient_of('is_ingredient_of');
    const LexRel(this.value);
    final String value;
}

enum OrthFormVariant{
  orthForm, orthVar, oldOrthForm, oldOrthVar
}

class Lexunit {
  String id;
  Synset synset;
  int sense;
  String source;
  bool named_enitity;
  bool style_marking;
  bool artificial;
  dynamic compound_info;
  String orthform;
  String old_orthform;
  String orthvar;
  String old_othvar;

  List frames = [];
  Map frames2examples = {};
  List examples = [];
  List ili_records = [];
  List wiktionary_paraphrases = [];

  Map relations = {};
  Map incoming_relations = {};

  Lexunit(this.id, this.synset, this.sense, this.source, this.named_enitity, this.style_marking, this.artificial, {
    this.compound_info = null, this.orthform = "", this.old_orthform = "", this.old_othvar = "", this.orthvar = "" 
  });

  String get_orthform_variant(OrthFormVariant orthFormVariant){

    if(orthFormVariant == OrthFormVariant.oldOrthVar){
      return old_othvar;
    }
    if(orthFormVariant == OrthFormVariant.oldOrthForm){
      return old_orthform;
    }
    if(orthFormVariant == OrthFormVariant.orthVar){
      return orthvar;
    }
    else{
      return orthform;
    }
  }

  Set get_all_orthforms(){

    Set forms = Set();
    for(OrthFormVariant variant in OrthFormVariant.values){
      String formVariant = get_orthform_variant(variant);
      if(formVariant != ""){
        forms.add(formVariant);
      }
    }
    return forms;
  }

  
}