import 'dart:typed_data';

///Because of the license for the source files, you should try to hide and encrypt the files, so that they cannot get stolen.
///if you have encrypted the source files you can use this interface to directly decrypt it inside the GermaNet source code (at a safe place).
///You can do that by creating a class that implements SecurityCryptInterpreter and that contains a method where you decrypt the source to readable text.
///Please note: Renaming the files names is NOT useful (it won't work)
abstract class SecurityCryptInterpreter {
  String decryptSource(Uint8List source);
}