import 'package:germanet_dart/src/compoundinfo.dart';
import 'package:germanet_dart/src/functools.dart';
import 'package:xml/xml.dart';


CompoundInfo create_compound_info(XmlElement child){
  var modifier1 = child.attributes.first;
  var modifier1prop = CompoundProperty.values.firstWhere((element) => element.name == modifier1.value);
  var modifier1cat = CompoundCategory.values.firstWhere((element) => element.name == modifier1.value);
  var modifier2 = null;
  var modifier2prop = null;
  var modifier2cat;
  var head = null;
  if(child.attributes.length == 3){

    modifier2 = child.attributes[1];
    head = child.attributes[2];

    modifier2prop = CompoundProperty.values.firstWhere((element) => element.name == modifier2.value);
    modifier2cat = CompoundCategory.values.firstWhere((element) => element.name == modifier2.value);
  }else{
    head = child.attributes[1];
  }
  var headprop = CompoundProperty.values.firstWhere((element) => element.name == head.value);
  var compound = CompoundInfo(modifier1.text, head.text, modifier1property: modifier1prop.name, modifier1category: simplifyEnumClass(modifier1cat), modifier2: modifier2, modifier2property: modifier2prop, modifier2category: modifier2cat, headproperty: headprop.name);

  return compound;
}
